import React from 'react';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = "";
styleInject(css_248z);

// let t0: number;
// let t1: number;
// t0 = performance.now();
var useAnimationFrame = function (callback, shouldStop) {
    var requestRef = React.useRef();
    var previousTimeRef = React.useRef();
    var animate = function (time) {
        if (previousTimeRef.current !== undefined) {
            var deltaTime = time - previousTimeRef.current;
            if (shouldStop === null || shouldStop === void 0 ? void 0 : shouldStop()) {
                // t1 = performance.now();
                // console.log("Call took " + (t1 - t0) + " milliseconds.")
                return;
            }
            callback(deltaTime);
        }
        previousTimeRef.current = time;
        requestRef.current = requestAnimationFrame(animate);
    };
    React.useEffect(function () {
        requestRef.current = requestAnimationFrame(animate);
        return function () { return cancelAnimationFrame(requestRef.current); };
    }, []);
};
var NumberWidgetCounter = function (_a) {
    var _b = _a.number, number = _b === void 0 ? 100 : _b, _c = _a.useClass, useClass = _c === void 0 ? 'number-widget-counter-class' : _c, _d = _a.factor, factor = _d === void 0 ? 1 : _d, _e = _a.timeMs, timeMs = _e === void 0 ? undefined : _e, _f = _a.stop, stop = _f === void 0 ? undefined : _f;
    var _g = __read(React.useState(0), 2), count = _g[0], setCount = _g[1];
    var countRef = React.useRef(0);
    React.useEffect(function () {
        countRef.current = count;
    }, [count]);
    useAnimationFrame(function (deltaTime) {
        setCount(function (prevCount) {
            var next = prevCount + (deltaTime * 0.01 * factor);
            if (timeMs) {
                var rendersCounts = timeMs / deltaTime;
                var incrementValue = number / rendersCounts;
                next = prevCount + (incrementValue);
            }
            if (next > number) {
                return number;
            }
            return next;
        });
    }, stop || (function () { return (countRef === null || countRef === void 0 ? void 0 : countRef.current) >= number; }));
    return React.createElement("div", { className: useClass }, Math.round(count));
};

export { NumberWidgetCounter };
//# sourceMappingURL=index.es.js.map
